﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		MainViewModel mvm;

		public MainPage()
		{
			InitializeComponent();

			this.mvm = new MainViewModel();
			this.DataContext = this.mvm;
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			this.mvm.Items.Add(new MyItem { Header = this.mvm.Items.Count.ToString() });
		}

		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			if (this.mvm.Items.Count > 0)
				this.mvm.Items.RemoveAt(0);
		}

		private void Button_Click_2(object sender, RoutedEventArgs e)
		{
			int startPos = 0;
			int endPos = 6;

			// This is the first way.
			// ***
			var item = this.mvm.Items[0];
			this.mvm.Items.RemoveAt(startPos);

			this.Dispatcher.BeginInvoke(new Action(() =>
			{
				this.mvm.Items.Insert(endPos, item);
			}));
			// ***

			//// This is the second way.
			//// ***
			//int offset = startPos - endPos;
			//if (offset < 0)
			//{
			//    for (int i = 0; i < Math.Abs(offset) - 1; i++)
			//    {
			//        this.mvm.Items[startPos].Position++;
			//    }
			//}
			//else
			//{
			//    for (int i = 0; i < offset - 1; i++)
			//    {
			//        this.mvm.Items[startPos].Position--;
			//    }
			//}
			//// ***
		}
	}
}
